import * as i0 from '@angular/core';
import { Injectable, Component, EventEmitter, Directive, Input, Output, HostListener, NgModule } from '@angular/core';

class NgxDragAndResizeService {
    constructor() { }
}
NgxDragAndResizeService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgxDragAndResizeService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NgxDragAndResizeService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgxDragAndResizeService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgxDragAndResizeService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return []; } });

class NgxDragAndResizeComponent {
    constructor() { }
    ngOnInit() { }
}
NgxDragAndResizeComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgxDragAndResizeComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NgxDragAndResizeComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgxDragAndResizeComponent, selector: "lib-ngx-drag-and-resize", ngImport: i0, template: ` <p>ngx-drag-and-resize works!</p> `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgxDragAndResizeComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-ngx-drag-and-resize',
                    template: ` <p>ngx-drag-and-resize works!</p> `,
                    styles: [],
                }]
        }], ctorParameters: function () { return []; } });

class DraggableElementDirective {
    constructor(elRef, renderer2) {
        this.elRef = elRef;
        this.renderer2 = renderer2;
        this.ngxBoundsContainerSelector = null;
        this.ngxDragStart = new EventEmitter();
        this.ngxDragging = new EventEmitter();
        this.ngxDragEnd = new EventEmitter();
        this.dragging = false;
        this.mousePosition = { x: 0, y: 0 };
        if (this.elRef.nativeElement.parentElement) {
            let parentStyle = window.getComputedStyle(this.elRef.nativeElement.parentElement);
            if ((parentStyle.alignItems && parentStyle.alignItems !== 'normal') ||
                (parentStyle.justifyContent && parentStyle.justifyContent !== 'normal')) {
                this.renderer2.setStyle(this.elRef.nativeElement.parentElement, 'alignItems', 'unset');
                this.renderer2.setStyle(this.elRef.nativeElement.parentElement, 'justifyContent', 'unset');
            }
        }
        this.elRef.nativeElement.addEventListener('mousedown', (ev) => {
            if (!ev.defaultPrevented && ev.returnValue) {
                this.dragging = true;
                this.ngxDragStart.emit();
                this.renderer2.setStyle(this.elRef.nativeElement, 'z-index', 999);
                ev.preventDefault();
            }
        });
    }
    onMouseMove(ev) {
        var _a, _b;
        if (this.dragging && this.mousePosition && !ev.defaultPrevented && ev.returnValue) {
            ev.preventDefault();
            let xDiff = ev.clientX - this.mousePosition.x;
            let yDiff = ev.clientY - this.mousePosition.y;
            let style = window.getComputedStyle(this.elRef.nativeElement);
            let matrix = new WebKitCSSMatrix(style.transform);
            let oldX = matrix.m41;
            let oldY = matrix.m42;
            let rect = (_b = (_a = this.elRef) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.getBoundingClientRect();
            const boundsContainer = typeof this.ngxBoundsContainerSelector === 'string'
                ? document.querySelector(this.ngxBoundsContainerSelector)
                : null;
            if (boundsContainer) {
                if (oldX + xDiff < boundsContainer.getBoundingClientRect().x) {
                    xDiff = boundsContainer.getBoundingClientRect().x - oldX;
                }
                if (oldX + xDiff + rect.width >
                    boundsContainer.getBoundingClientRect().x + boundsContainer.getBoundingClientRect().width) {
                    xDiff =
                        boundsContainer.getBoundingClientRect().x +
                            boundsContainer.getBoundingClientRect().width -
                            (oldX + rect.width);
                }
                if (oldY + yDiff < boundsContainer.getBoundingClientRect().y) {
                    yDiff = boundsContainer.getBoundingClientRect().y - oldY;
                }
                if (oldY + yDiff + rect.height >
                    boundsContainer.getBoundingClientRect().y + boundsContainer.getBoundingClientRect().height) {
                    yDiff =
                        boundsContainer.getBoundingClientRect().y +
                            boundsContainer.getBoundingClientRect().height -
                            (oldY + rect.height);
                }
            }
            this.renderer2.setStyle(this.elRef.nativeElement, 'transform', this.asTranslateString(oldX + xDiff, oldY + yDiff));
            this.ngxDragging.emit();
        }
        this.mousePosition = { x: ev.clientX, y: ev.clientY };
    }
    onMouseUp(ev) {
        var _a;
        if (this.dragging) {
            (_a = this.ngxDragEnd) === null || _a === void 0 ? void 0 : _a.emit();
            this.dragging = false;
            this.renderer2.setStyle(this.elRef.nativeElement, 'z-index', 1);
        }
    }
    asTranslateString(x, y) {
        return `translate(${this.asPxString(x)},${this.asPxString(y)})`;
    }
    asPxString(num) {
        return num.toString().concat('px');
    }
}
DraggableElementDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: DraggableElementDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
DraggableElementDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.10", type: DraggableElementDirective, selector: "[draggableElement]", inputs: { ngxBoundsContainerSelector: "ngxBoundsContainerSelector" }, outputs: { ngxDragStart: "ngxDragStart", ngxDragging: "ngxDragging", ngxDragEnd: "ngxDragEnd" }, host: { listeners: { "window:mousemove": "onMouseMove($event)", "window:mouseup": "onMouseUp($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: DraggableElementDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[draggableElement]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { ngxBoundsContainerSelector: [{
                type: Input
            }], ngxDragStart: [{
                type: Output
            }], ngxDragging: [{
                type: Output
            }], ngxDragEnd: [{
                type: Output
            }], onMouseMove: [{
                type: HostListener,
                args: ['window:mousemove', ['$event']]
            }], onMouseUp: [{
                type: HostListener,
                args: ['window:mouseup', ['$event']]
            }] } });

class ResizableElementDirective {
    constructor(elRef, renderer2) {
        var _a, _b, _c, _d, _e, _f;
        this.elRef = elRef;
        this.renderer2 = renderer2;
        this.handlerSize = 20;
        this.ngxBoundsContainerSelector = null;
        this.ngxResizeStart = new EventEmitter();
        this.ngxResizing = new EventEmitter();
        this.ngxResizeEnd = new EventEmitter();
        this.mousePosition = { x: 0, y: 0 };
        if (this.elRef.nativeElement.parentElement) {
            let parentStyle = window.getComputedStyle(this.elRef.nativeElement.parentElement);
            if ((parentStyle.alignItems && parentStyle.alignItems !== 'normal') ||
                (parentStyle.justifyContent && parentStyle.justifyContent !== 'normal')) {
                this.renderer2.setStyle(this.elRef.nativeElement.parentElement, 'alignItems', 'unset');
                this.renderer2.setStyle(this.elRef.nativeElement.parentElement, 'justifyContent', 'unset');
            }
        }
        if (((_b = (_a = elRef === null || elRef === void 0 ? void 0 : elRef.nativeElement) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.position) !== 'absolute' &&
            ((_d = (_c = elRef === null || elRef === void 0 ? void 0 : elRef.nativeElement) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.position) !== 'relative' &&
            ((_f = (_e = elRef === null || elRef === void 0 ? void 0 : elRef.nativeElement) === null || _e === void 0 ? void 0 : _e.style) === null || _f === void 0 ? void 0 : _f.position) !== 'fixed') {
            console.warn('Element set to position: relative to position resize Handlers. A resizable Element should be positioned absolute or relative');
            this.renderer2.setStyle(this.elRef.nativeElement, 'position', 'relative');
        }
        const handlers = [];
        const resizeHandleTypes = ['TopLeft', 'Top', 'TopRight', 'Right', 'BottomRight', 'Bottom', 'BottomLeft', 'Left'];
        for (let i = 0; i < 8; i++) {
            const handle = document.createElement('div');
            this.renderer2.setStyle(handle, 'width', i === 1 || i === 5 ? `calc(100% - ${this.asPxString(this.handlerSize)})` : this.asPxString(this.handlerSize));
            this.renderer2.setStyle(handle, 'height', i === 3 || i === 7 ? `calc(100% - ${this.asPxString(this.handlerSize)})` : this.asPxString(this.handlerSize));
            handle.id = `resizableElementResizeHandler${resizeHandleTypes[i]}`;
            handle.classList.add('resizableElementResizeHandler');
            handlers.push(handle);
        }
        for (let i = 0; i < handlers.length; i++) {
            const handler = handlers[i];
            this.renderer2.appendChild(elRef.nativeElement, handler);
            this.renderer2.setStyle(handler, 'z-index', 10);
            this.renderer2.setStyle(handler, 'position', 'absolute');
            switch (i) {
                case 0:
                    this.renderer2.setStyle(handler, 'cursor', 'nw-resize');
                    // this.renderer2.setStyle(handler, 'background-color', 'green');
                    this.renderer2.setStyle(handler, 'left', this.asPxString(-this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'top', this.asPxString(-this.handlerSize / 2));
                    break;
                case 1:
                    this.renderer2.setStyle(handler, 'cursor', 'n-resize');
                    // this.renderer2.setStyle(handler, 'background-color', 'lightgreen');
                    this.renderer2.setStyle(handler, 'left', this.asPxString(this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'right', this.asPxString(this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'top', this.asPxString(-this.handlerSize / 2));
                    break;
                case 2:
                    this.renderer2.setStyle(handler, 'cursor', 'ne-resize');
                    // this.renderer2.setStyle(handler, 'background-color', 'red');
                    this.renderer2.setStyle(handler, 'right', this.asPxString(-this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'top', this.asPxString(-this.handlerSize / 2));
                    break;
                case 3:
                    this.renderer2.setStyle(handler, 'cursor', 'e-resize');
                    // this.renderer2.setStyle(handler, 'background-color', 'pink');
                    this.renderer2.setStyle(handler, 'top', this.asPxString(this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'bottom', this.asPxString(this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'right', this.asPxString(-this.handlerSize / 2));
                    break;
                case 4:
                    this.renderer2.setStyle(handler, 'cursor', 'se-resize');
                    // this.renderer2.setStyle(handler, 'background-color', 'darkblue');
                    this.renderer2.setStyle(handler, 'right', this.asPxString(-this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'bottom', this.asPxString(-this.handlerSize / 2));
                    break;
                case 5:
                    this.renderer2.setStyle(handler, 'cursor', 's-resize');
                    // this.renderer2.setStyle(handler, 'background-color', 'black');
                    this.renderer2.setStyle(handler, 'right', this.asPxString(this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'left', this.asPxString(this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'bottom', this.asPxString(-this.handlerSize / 2));
                    break;
                case 6:
                    this.renderer2.setStyle(handler, 'cursor', 'sw-resize');
                    // this.renderer2.setStyle(handler, 'background-color', 'orange');
                    this.renderer2.setStyle(handler, 'left', this.asPxString(-this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'bottom', this.asPxString(-this.handlerSize / 2));
                    break;
                case 7:
                    this.renderer2.setStyle(handler, 'cursor', 'w-resize');
                    // this.renderer2.setStyle(handler, 'background-color', 'yellow');
                    this.renderer2.setStyle(handler, 'top', this.asPxString(this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'bottom', this.asPxString(this.handlerSize / 2));
                    this.renderer2.setStyle(handler, 'left', this.asPxString(-this.handlerSize / 2));
                    break;
                default:
                    break;
            }
            handler.addEventListener('mousedown', (ev) => {
                this.currentResizingHandler = handler;
                this.ngxResizeStart.emit();
                ev.stopPropagation();
            });
        }
    }
    onMouseMove(event) {
        if (this.currentResizingHandler && this.mousePosition) {
            this.unFocus();
            event.preventDefault();
            event.cancelBubble = true;
            const xDiff = event.clientX - this.mousePosition.x;
            const yDiff = event.clientY - this.mousePosition.y;
            let style = window.getComputedStyle(this.elRef.nativeElement);
            let matrix = new WebKitCSSMatrix(style.transform);
            let oldX = matrix.m41;
            let oldY = matrix.m42;
            let boundingElement;
            if (typeof this.ngxBoundsContainerSelector === 'string') {
                boundingElement = document.querySelector(this.ngxBoundsContainerSelector);
                if (!boundingElement) {
                    console.warn(`Bounding Element not found with selector ${this.ngxBoundsContainerSelector} \n
          Check your input and DOM for the Element`);
                }
            }
            switch (this.currentResizingHandler.id) {
                case 'resizableElementResizeHandlerTopLeft':
                    this.resizeLeft(boundingElement, oldX, oldY, xDiff);
                    style = window.getComputedStyle(this.elRef.nativeElement);
                    matrix = new WebKitCSSMatrix(style.transform);
                    oldX = matrix.m41;
                    oldY = matrix.m42;
                    this.resizeTop(boundingElement, oldX, oldY, yDiff);
                    break;
                case 'resizableElementResizeHandlerTop':
                    this.resizeTop(boundingElement, oldX, oldY, yDiff);
                    break;
                case 'resizableElementResizeHandlerTopRight':
                    this.resizeRight(boundingElement, oldX, oldY, xDiff);
                    this.resizeTop(boundingElement, oldX, oldY, yDiff);
                    break;
                case 'resizableElementResizeHandlerRight':
                    this.resizeRight(boundingElement, oldX, oldY, xDiff);
                    break;
                case 'resizableElementResizeHandlerBottomRight':
                    this.resizeRight(boundingElement, oldX, oldY, xDiff);
                    this.resizeBottom(boundingElement, oldX, oldY, yDiff);
                    break;
                case 'resizableElementResizeHandlerBottom':
                    this.resizeBottom(boundingElement, oldX, oldY, yDiff);
                    break;
                case 'resizableElementResizeHandlerBottomLeft':
                    this.resizeLeft(boundingElement, oldX, oldY, xDiff);
                    this.resizeBottom(boundingElement, oldX, oldY, yDiff);
                    break;
                case 'resizableElementResizeHandlerLeft':
                    this.resizeLeft(boundingElement, oldX, oldY, xDiff);
                    break;
                default:
                    break;
            }
            this.ngxResizing.emit();
        }
        this.mousePosition = { x: event.clientX, y: event.clientY };
    }
    resizeLeft(boundingElement, oldX, oldY, xDiff) {
        var _a, _b;
        if (!boundingElement ||
            ((_b = (_a = this.currentResizingHandler) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect()) === null || _b === void 0 ? void 0 : _b.x) - xDiff > boundingElement.getBoundingClientRect().x) {
            this.renderer2.setStyle(this.elRef.nativeElement, 'width', this.asPxString(this.elRef.nativeElement.getBoundingClientRect().width - xDiff));
            this.renderer2.setStyle(this.elRef.nativeElement, 'transform', this.asTransformString(oldX + xDiff, oldY));
        }
    }
    resizeTop(boundingElement, oldX, oldY, yDiff) {
        var _a, _b;
        if (!boundingElement ||
            ((_b = (_a = this.currentResizingHandler) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect()) === null || _b === void 0 ? void 0 : _b.y) - yDiff > boundingElement.getBoundingClientRect().y) {
            this.renderer2.setStyle(this.elRef.nativeElement, 'height', this.asPxString(this.elRef.nativeElement.getBoundingClientRect().height - yDiff));
            this.renderer2.setStyle(this.elRef.nativeElement, 'transform', this.asTransformString(oldX, oldY + yDiff));
        }
    }
    resizeRight(boundingElement, oldX, oldY, xDiff) {
        var _a, _b;
        if (!boundingElement ||
            ((_b = (_a = this.currentResizingHandler) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect()) === null || _b === void 0 ? void 0 : _b.x) + xDiff <
                boundingElement.getBoundingClientRect().x + boundingElement.getBoundingClientRect().width) {
            this.renderer2.setStyle(this.elRef.nativeElement, 'width', this.asPxString(this.elRef.nativeElement.getBoundingClientRect().width + xDiff));
        }
    }
    resizeBottom(boundingElement, oldX, oldY, yDiff) {
        var _a, _b;
        if (!boundingElement ||
            ((_b = (_a = this.currentResizingHandler) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect()) === null || _b === void 0 ? void 0 : _b.y) + yDiff <
                boundingElement.getBoundingClientRect().y + boundingElement.getBoundingClientRect().height) {
            this.renderer2.setStyle(this.elRef.nativeElement, 'height', this.asPxString(this.elRef.nativeElement.getBoundingClientRect().height + yDiff));
        }
    }
    onMouseUp(ev) {
        var _a;
        if (this.currentResizingHandler) {
            (_a = this.ngxResizeEnd) === null || _a === void 0 ? void 0 : _a.emit();
            this.currentResizingHandler = null;
            this.unFocus();
        }
    }
    asTransformString(x, y, xScale = 1, yScale = 1) {
        return `translate(${this.asPxString(x)},${this.asPxString(y)}) scale(${xScale}, ${yScale})`;
    }
    asPxString(num) {
        return num.toString().concat('px');
    }
    parsePxString(pxStr) {
        var _a, _b;
        const numberPattern = /\d+/g;
        pxStr !== null && pxStr !== void 0 ? pxStr : (pxStr = '');
        if (!(pxStr === null || pxStr === void 0 ? void 0 : pxStr.includes('px'))) {
            console.warn('Tried to parse non px String!');
            return NaN;
        }
        else {
            return Number.parseFloat((_b = (_a = pxStr === null || pxStr === void 0 ? void 0 : pxStr.match(numberPattern)) === null || _a === void 0 ? void 0 : _a.join('')) !== null && _b !== void 0 ? _b : '');
        }
    }
    unFocus() {
        var _a, _b;
        if (document.getSelection()) {
            (_a = document.getSelection()) === null || _a === void 0 ? void 0 : _a.empty();
        }
        else {
            (_b = window.getSelection()) === null || _b === void 0 ? void 0 : _b.removeAllRanges();
        }
    }
}
ResizableElementDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: ResizableElementDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
ResizableElementDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.10", type: ResizableElementDirective, selector: "[resizableElement]", inputs: { handlerSize: "handlerSize", ngxBoundsContainerSelector: "ngxBoundsContainerSelector" }, outputs: { ngxResizeStart: "ngxResizeStart", ngxResizing: "ngxResizing", ngxResizeEnd: "ngxResizeEnd" }, host: { listeners: { "window:mousemove": "onMouseMove($event)", "window:mouseup": "onMouseUp($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: ResizableElementDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[resizableElement]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { handlerSize: [{
                type: Input
            }], ngxBoundsContainerSelector: [{
                type: Input
            }], ngxResizeStart: [{
                type: Output
            }], ngxResizing: [{
                type: Output
            }], ngxResizeEnd: [{
                type: Output
            }], onMouseMove: [{
                type: HostListener,
                args: ['window:mousemove', ['$event']]
            }], onMouseUp: [{
                type: HostListener,
                args: ['window:mouseup', ['$event']]
            }] } });

class NgxDragAndResizeModule {
}
NgxDragAndResizeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgxDragAndResizeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxDragAndResizeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgxDragAndResizeModule, declarations: [NgxDragAndResizeComponent, DraggableElementDirective, ResizableElementDirective], exports: [NgxDragAndResizeComponent, DraggableElementDirective, ResizableElementDirective] });
NgxDragAndResizeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgxDragAndResizeModule, imports: [[]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgxDragAndResizeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgxDragAndResizeComponent, DraggableElementDirective, ResizableElementDirective],
                    imports: [],
                    exports: [NgxDragAndResizeComponent, DraggableElementDirective, ResizableElementDirective],
                }]
        }] });

/*
 * Public API Surface of ngx-drag-and-resize
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DraggableElementDirective, NgxDragAndResizeComponent, NgxDragAndResizeModule, NgxDragAndResizeService, ResizableElementDirective };
//# sourceMappingURL=ngx-drag-and-resize.mjs.map
