import { ElementRef, EventEmitter, Renderer2 } from '@angular/core';
import * as i0 from "@angular/core";
export declare class ResizableElementDirective {
    private elRef;
    private renderer2;
    handlerSize: number;
    ngxBoundsContainerSelector: string | null;
    ngxResizeStart: EventEmitter<void>;
    ngxResizing: EventEmitter<void>;
    ngxResizeEnd: EventEmitter<void>;
    private mousePosition;
    private currentResizingHandler;
    constructor(elRef: ElementRef<HTMLElement>, renderer2: Renderer2);
    onMouseMove(event: MouseEvent): void;
    resizeLeft(boundingElement: Element | null | undefined, oldX: number, oldY: number, xDiff: number): void;
    resizeTop(boundingElement: Element | null | undefined, oldX: number, oldY: number, yDiff: number): void;
    resizeRight(boundingElement: Element | null | undefined, oldX: number, oldY: number, xDiff: number): void;
    resizeBottom(boundingElement: Element | null | undefined, oldX: number, oldY: number, yDiff: number): void;
    onMouseUp(ev: MouseEvent): void;
    asTransformString(x: number, y: number, xScale?: number, yScale?: number): string;
    asPxString(num: number): string;
    parsePxString(pxStr: string): number;
    unFocus(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ResizableElementDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ResizableElementDirective, "[resizableElement]", never, { "handlerSize": "handlerSize"; "ngxBoundsContainerSelector": "ngxBoundsContainerSelector"; }, { "ngxResizeStart": "ngxResizeStart"; "ngxResizing": "ngxResizing"; "ngxResizeEnd": "ngxResizeEnd"; }, never>;
}
